# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ServiceQuotaUsageMetric',
    'ServiceQuotaUsageMetricMetricDimension',
    'GetServiceQuotaUsageMetricResult',
    'GetServiceQuotaUsageMetricMetricDimensionResult',
]

@pulumi.output_type
class ServiceQuotaUsageMetric(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "metricDimensions":
            suggest = "metric_dimensions"
        elif key == "metricName":
            suggest = "metric_name"
        elif key == "metricNamespace":
            suggest = "metric_namespace"
        elif key == "metricStatisticRecommendation":
            suggest = "metric_statistic_recommendation"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceQuotaUsageMetric. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceQuotaUsageMetric.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceQuotaUsageMetric.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 metric_dimensions: Optional[Sequence['outputs.ServiceQuotaUsageMetricMetricDimension']] = None,
                 metric_name: Optional[str] = None,
                 metric_namespace: Optional[str] = None,
                 metric_statistic_recommendation: Optional[str] = None):
        """
        :param Sequence['ServiceQuotaUsageMetricMetricDimensionArgs'] metric_dimensions: The metric dimensions.
        :param str metric_name: The name of the metric.
        :param str metric_namespace: The namespace of the metric.
        :param str metric_statistic_recommendation: The metric statistic that AWS recommend you use when determining quota usage.
        """
        if metric_dimensions is not None:
            pulumi.set(__self__, "metric_dimensions", metric_dimensions)
        if metric_name is not None:
            pulumi.set(__self__, "metric_name", metric_name)
        if metric_namespace is not None:
            pulumi.set(__self__, "metric_namespace", metric_namespace)
        if metric_statistic_recommendation is not None:
            pulumi.set(__self__, "metric_statistic_recommendation", metric_statistic_recommendation)

    @property
    @pulumi.getter(name="metricDimensions")
    def metric_dimensions(self) -> Optional[Sequence['outputs.ServiceQuotaUsageMetricMetricDimension']]:
        """
        The metric dimensions.
        """
        return pulumi.get(self, "metric_dimensions")

    @property
    @pulumi.getter(name="metricName")
    def metric_name(self) -> Optional[str]:
        """
        The name of the metric.
        """
        return pulumi.get(self, "metric_name")

    @property
    @pulumi.getter(name="metricNamespace")
    def metric_namespace(self) -> Optional[str]:
        """
        The namespace of the metric.
        """
        return pulumi.get(self, "metric_namespace")

    @property
    @pulumi.getter(name="metricStatisticRecommendation")
    def metric_statistic_recommendation(self) -> Optional[str]:
        """
        The metric statistic that AWS recommend you use when determining quota usage.
        """
        return pulumi.get(self, "metric_statistic_recommendation")


@pulumi.output_type
class ServiceQuotaUsageMetricMetricDimension(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "class":
            suggest = "class_"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ServiceQuotaUsageMetricMetricDimension. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ServiceQuotaUsageMetricMetricDimension.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ServiceQuotaUsageMetricMetricDimension.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 class_: Optional[str] = None,
                 resource: Optional[str] = None,
                 service: Optional[str] = None,
                 type: Optional[str] = None):
        if class_ is not None:
            pulumi.set(__self__, "class_", class_)
        if resource is not None:
            pulumi.set(__self__, "resource", resource)
        if service is not None:
            pulumi.set(__self__, "service", service)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="class")
    def class_(self) -> Optional[str]:
        return pulumi.get(self, "class_")

    @property
    @pulumi.getter
    def resource(self) -> Optional[str]:
        return pulumi.get(self, "resource")

    @property
    @pulumi.getter
    def service(self) -> Optional[str]:
        return pulumi.get(self, "service")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        return pulumi.get(self, "type")


@pulumi.output_type
class GetServiceQuotaUsageMetricResult(dict):
    def __init__(__self__, *,
                 metric_dimensions: Sequence['outputs.GetServiceQuotaUsageMetricMetricDimensionResult'],
                 metric_name: str,
                 metric_namespace: str,
                 metric_statistic_recommendation: str):
        """
        :param Sequence['GetServiceQuotaUsageMetricMetricDimensionArgs'] metric_dimensions: The metric dimensions.
        :param str metric_name: The name of the metric.
        :param str metric_namespace: The namespace of the metric.
        :param str metric_statistic_recommendation: The metric statistic that AWS recommend you use when determining quota usage.
        """
        pulumi.set(__self__, "metric_dimensions", metric_dimensions)
        pulumi.set(__self__, "metric_name", metric_name)
        pulumi.set(__self__, "metric_namespace", metric_namespace)
        pulumi.set(__self__, "metric_statistic_recommendation", metric_statistic_recommendation)

    @property
    @pulumi.getter(name="metricDimensions")
    def metric_dimensions(self) -> Sequence['outputs.GetServiceQuotaUsageMetricMetricDimensionResult']:
        """
        The metric dimensions.
        """
        return pulumi.get(self, "metric_dimensions")

    @property
    @pulumi.getter(name="metricName")
    def metric_name(self) -> str:
        """
        The name of the metric.
        """
        return pulumi.get(self, "metric_name")

    @property
    @pulumi.getter(name="metricNamespace")
    def metric_namespace(self) -> str:
        """
        The namespace of the metric.
        """
        return pulumi.get(self, "metric_namespace")

    @property
    @pulumi.getter(name="metricStatisticRecommendation")
    def metric_statistic_recommendation(self) -> str:
        """
        The metric statistic that AWS recommend you use when determining quota usage.
        """
        return pulumi.get(self, "metric_statistic_recommendation")


@pulumi.output_type
class GetServiceQuotaUsageMetricMetricDimensionResult(dict):
    def __init__(__self__, *,
                 class_: str,
                 resource: str,
                 service: str,
                 type: str):
        pulumi.set(__self__, "class_", class_)
        pulumi.set(__self__, "resource", resource)
        pulumi.set(__self__, "service", service)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="class")
    def class_(self) -> str:
        return pulumi.get(self, "class_")

    @property
    @pulumi.getter
    def resource(self) -> str:
        return pulumi.get(self, "resource")

    @property
    @pulumi.getter
    def service(self) -> str:
        return pulumi.get(self, "service")

    @property
    @pulumi.getter
    def type(self) -> str:
        return pulumi.get(self, "type")


